var p2 = require('p2');

var on = false;

exports.world = function(context, world) {
  context.save();
  world.bodies.forEach(function(body) {
    drawBody(context, body);
  });
  context.restore();
};

function drawBody(context, body) {
  body.updateAABB();
  var aabb = body.aabb;
  if (on) {
    context.beginPath();
    context.rect(
      aabb.lowerBound[0],
      aabb.lowerBound[1],
      aabb.upperBound[0] - aabb.lowerBound[0],
      aabb.upperBound[1] - aabb.lowerBound[1]
    );
    context.stroke();
  }

  var pos = body.position;

  if (on) {
  context.save();
  context.translate(pos[0], pos[1]);
  }

  body.shapes.forEach(function(shape) {
    drawShape(context, shape);
  });

  if (on)
    context.restore();
}


function drawShape(context, shape) {
  if (!on)
    return;

  let type = shape.type;

  if (type === p2.Shape.CIRCLE) {
    context.beginPath();
    context.arc(
      0, 0, shape.radius, 0, 2 * Math.PI
    );
    context.stroke();
  }

}
