var _ = require('lodash');
var cell = require('frp').cell;
var V = require('mxd').Vector;


module.exports = function(map) {

  map = map || {
    'A': [-1, 0],
    'D': [1, 0],
    'W': [0, -1],
    'S': [0, 1]
  };

  var codeMap = {};
  _.forEach(map, function(v, k) {
    codeMap[k.charCodeAt(0)] = v;
  });

  var down = {};

  var r = cell([0, 0]);

  function update() {
    r.set(
      V.norm(V.sum(
        Object.keys(down).map(function(code) {
          return codeMap[code] || [0, 0];
        })
      ))
    );
  }

  window.addEventListener('keydown', function(e) {
    if (!down[e.keyCode]) {
      down[e.keyCode] = true;
      update();
    }
  });

  window.addEventListener('keyup', function(e) {
    delete down[e.keyCode];
    update();
  });

  return r.signal;
};
