var _ = require('lodash');
var proutines = require('proutines');


module.exports = function(ng) {

  var sys = {};

  var nodes = {};

  var deps = {};

  sys.depend = function(child, parent) {
    deps[parent] = deps[parent] || [];
    deps[parent].push(child);
  };

  sys.cleanup = function(foreignNodes, dtor) {
    let dead = [];
    _.forEach(foreignNodes, function(foreignNode, id) {
      let node = nodes[id];
      if (node) {
        (dtor || _.identity)(foreignNode, id);
        dead.push(id);
      }
    });
    dead.forEach(function(id) { 
      delete foreignNodes[id];
    });
  };

  sys.kill = function(id) {
    nodes[id] = 1;
  };

  sys.isDying = function(id) {
    return id in nodes;
  };

  sys.update = function(dt) {
    var dead = [];
    _.forEach(nodes, function(state, id) {

      if (state == 2)
        dead.push(id);

      else if (state == 1) {
        state = 2;

        (deps[id] || []).forEach(function(dep) {
          nodes[dep] = 1;
        });
      }

    });
    dead.forEach(function(id) {
      delete nodes[id];
    });
  };

  return sys;
};
