var V = require('mxd/Vector');
var T = require('ace/transform');

function View(context, tr, time) {
  this._context = context;
  this._tr = tr || T.identity;
  this._time = time || 0;
}

View.prototype.transform = function(newTr) {
  return new View(this._context, T.mul(newTr, this._tr), this._time);
};

View.prototype.getTransform = function() {
  return this._tr;
};

View.prototype.getViewport = function() {
  var can = this._context.canvas;
  return [can.width, can.height];
};

View.prototype.withContext = function(cb) {
  var context = this._context;
  context.save();

  var tr1 = T.copy(this._tr, {
    pos: V.floor(this._tr.pos)
  });

  T.applyToContext(tr1, context);
  cb(context);
  context.restore();

};

Object.defineProperties(View.prototype, {
  time: { get: function() { return this._time; }}
});

module.exports = function makeView(context, tr, time) {
  return new View(context, tr, time);
};
