var _ = require('lodash');

var graphics = require('ace/graphics');

var Cell = require('frp').cell;
var Signal = require('frp').signal;

var gfxNames = [
  'bkg', 'boy-stand', 'boy-walk-1', 'boy-walk-2', 'shadow',
  'reveal', 'box', 'pusher', 'minelayer', 'truck', 'dead', 'snowfa',
  'snowman', 'snowsit', 'end', 'snowball', 'snow1', 'snow2', 'apple',
  'title'
];
var gfx = module.exports;



module.exports.loadGraphics = function() {
  var r = Cell();
  var gfxPaths = gfxNames.map(function(x) { return 'assets/' + x + '.png'; });
  var gfxCells = _.object(gfxNames, gfxPaths.map(graphics.load));
  Signal.collect(gfxCells).watch(function(images) {

    _.forEach(images, function(i, k) {
      gfx[k] = i;
    });

    r.set(gfx);
  });
  return r.signal;
};
